[ANN] containers 2.4


#1

Howdy y’all,

I have the pleasure to announce that containers 2.4 was just released and has been merged into opam. Highlights include more labelled modules, migration to dune and opam2, a few new combinators, and some bugfixes. Thanks to all the contributors and issue reporters!

Full release here.


#2

2.4

breaking

It seems that you have also broken List.remove and List.Assoc.update

What bothers me in the ocaml community is how people tend to ignore semantic versioning and break things on minor releases (even in the compiler). Why not to keep legacy functions marked as deprecated until the next major release and break on 3.0? Maybe this is minor and unimportant change, but I’ve already had some broken code due to _exn/_opt confusion on a minor update.

Lwt people are really great in making versioning right.


#3

(even in the compiler)

Note that AFAIU the compiler version numbers are language.major.minor,
so the change from 4.06 to 4.07 is a major release.


#4

This breakage was not intended, sorry. I try to stick to semantic versioning for containers, but tooling doesn’t provide a good way, afaik, to automatically check compatibility. I’ll try to make a release candidate next time so people can check in advance.